local Sorcerer = ...

local myMonument = {
    Id = _SorcererPrefix .. "_MONUMENT",
    Name = _SorcererPrefix .. "_MONUMENT_NAME",
    Description = _SorcererPrefix .. "_MONUMENT_DESC",
    BuildingType = "MONUMENT"
}

if (foundation.getGameVersion == nil or version.cmp(foundation.getGameVersion(), "1.6") < 0) then
    Sorcerer:log("Hello World: version 1.5")
    SorcererTagBehaviorWork = "WORK_BEHAVIOR"
    myMonument.DataType = "MONUMENT"
    _SorcererHouse2BuildingZone = { Polygon = polygon.createRectangle( {4, 4} ) } 
else
    Sorcerer:log("Hello World: version " .. foundation.getGameVersion())
    myMonument.DataType = "BUILDING"

    Sorcerer:registerAssetId("models/core.fbx/Prefab/CoreBuildingPart", _SorcererPrefix .. "_CORE_BUILDING_PREFAB")

    -- Register the Core part
    Sorcerer:register({
	DataType = "BUILDING_PART",
	Id = _SorcererPrefix .. "_CORE_BUILDING_PART",
	Name = _SorcererPrefix .. "_CORE_BUILDING_NAME",
	Description = _SorcererPrefix .. "_CORE_BUILDING_DESC",
	Category = "CORE",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = _SorcererPrefix .. "_CORE_BUILDING_PREFAB"
	},
        IsVisibleWhenBuilt = false
    })
    myMonument.AssetCoreBuildingPart = _SorcererPrefix .. "_CORE_BUILDING_PART"
    SorcererTagBehaviorWork = "BEHAVIOR_WORK"
    if version.cmp(foundation.getGameVersion(), "1.6.6") < 0 then
        Sorcerer:log("Hello World: version 1.6.5")
        _SorcererHouse2BuildingZone = { Polygon = polygon.createRectangle( {4, 4} ) } 
    else
        Sorcerer:log("Hello World: version 1.6.6")
        _SorcererHouse2BuildingZone = { ZoneEntryList = {
            { Polygon = polygon.createRectangle( {4, 4} ),
              Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } }
        }}
   end
end

-- Register all building parts and their properties
Sorcerer:dofile("scripts/sorcererHouse2.lua")

myMonument.BuildingPartSetList = {
		{
			Name = _SorcererPrefix .. "2_PARTSETLIST_NAME",
                	BuildingPartList = { _SorcererPrefix .. "2_ROOT_PART" }
                }
} 
myMonument.RequiredPartList = {
		-- Necessarily a list of 'MONUMENT_REQUIRED_PART_PAIR', no need to specify the DataType of each element of the list
		{ Category = "CORE", Quantity = 1 }
}
myMonument.IsEditable = true

Sorcerer:register(myMonument)

